unit DBTrees;

interface

uses ComCtrls, DB;

type

  TTreeNodeInfo=record
   Id:String;
   ParentId:String;
  end;

  TDBTreeView=class(TTreeView)
   private
    fTable:TDataSet;
    fId,fParentId,fName:string;
    function AddItem:TTreeNode;
    function FindItem(Id:string):TTreeNode;
   public
    function GetId:string;
    procedure BuildTree;
    procedure ClearTree;
   published
    property FieldId:string Read fId Write fId;
    property FieldParentId:string Read fParentId Write fParentId;
    property FieldName:string Read fName Write fName;
    property DataSource:TDataSet Read fTable Write fTable;
    property ActiveId:string Read GetId;
  end;

procedure Register;

implementation

function TDBTreeView.FindItem(Id:string):TTreeNode;
 var i:integer;
     NodeInfo:^TTreeNodeInfo;
begin
 Result:=nil;
 For i:=0 to Items.Count-1 do
 begin
  NodeInfo:=Items[i].Data;
  If NodeInfo^.Id=Id then
  begin
   Result:=Items[i];
   Exit;
  end;
 end;
end;

function TDBTreeView.GetId:string;
 var NodeInfo:^TTreeNodeInfo;
begin
 If Selected=nil then Result:=''
 else
 begin
  NodeInfo:=Selected.Data;
  Result:=NodeInfo^.Id;
 end;
end;

function TDBTreeView.AddItem:TTreeNode;
 var NodeInfo:^TTreeNodeInfo;
     BMark:TBookMark;
     ObjParent:TTreeNode;
     Name,CurId:string;
begin
 ObjParent:=FindItem(fTable.FieldByName(fId).AsString);
 If ObjParent<>nil then
 {    }
 begin
  Result:=ObjParent;
  Exit;
 end
 else
 {   }
 begin
  New(NodeInfo);
  NodeInfo^.Id:=fTable.FieldByName(fId).AsString;
  NodeInfo^.ParentId:=fTable.FieldByName(fParentId).AsString;
  Name:=fTable.FieldByName(fName).AsString;
  If fTable.FieldByName(fParentId).AsString<>'' then
  {   }
  begin
   { }
   ObjParent:=FindItem(Name);
   If ObjParent<>nil then
    {   }
    Result:=Items.AddChildObject(ObjParent,Name,NodeInfo)
   else
   begin
    CurId:=fTable.FieldByName(fId).AsString;
    If fTable.Locate(fId,fTable.FieldByName(fParentId).AsString,[]) then
    begin
     Result:=Items.AddChildObject(AddItem,Name,NodeInfo);
     fTable.Locate(fId,CurId,[]);
    end
    else
     Result:=Items.AddObject(Selected,Name,NodeInfo);
   end;
  end
  else
  {  }
  begin
   Result:=Items.AddObject(Selected,Name,NodeInfo);
  end;
 end;
end;

procedure TDBTreeView.BuildTree;
 var ChangeEvent:TTVChangedEvent;
begin
 If (fTable=nil) or (not fTable.Active) then Exit;
 ChangeEvent:=OnChange;
 OnChange:=nil;
 Items.BeginUpdate;
 ClearTree;
 fTable.First;
 While not fTable.Eof do
 begin
  AddItem;
  fTable.Next;
 end;
 AlphaSort;
 Items.EndUpdate;
 OnChange:=ChangeEvent;
end;

procedure TDBTreeView.ClearTree;
 var NodeInfo:^TTreeNodeInfo;
     i:integer;
begin
 Items.BeginUpdate;
 For i:=0 to Items.Count-1 do
 begin
  NodeInfo:=items[i].Data;
  Dispose(NodeInfo);
 end;
 While Items.Count>0 do Items.Delete(Items[0]);
 Items.EndUpdate;
end;

procedure Register;
begin
 RegisterComponents('Data Controls',[TDBTreeView]);
end;

end.
